# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Fitness.V1.Model.ListDataPointChangesResponse do
  @moduledoc """


  ## Attributes

  *   `dataSourceId` (*type:* `String.t`, *default:* `nil`) - The data stream ID of the data source with data point changes.
  *   `deletedDataPoint` (*type:* `list(GoogleApi.Fitness.V1.Model.DataPoint.t)`, *default:* `nil`) - Deleted data points for the user. Note, for modifications this should be parsed before handling insertions.
  *   `insertedDataPoint` (*type:* `list(GoogleApi.Fitness.V1.Model.DataPoint.t)`, *default:* `nil`) - Inserted data points for the user.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The continuation token, which is used to page through large result sets. Provide this value in a subsequent request to return the next page of results.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :dataSourceId => String.t(),
          :deletedDataPoint => list(GoogleApi.Fitness.V1.Model.DataPoint.t()),
          :insertedDataPoint => list(GoogleApi.Fitness.V1.Model.DataPoint.t()),
          :nextPageToken => String.t()
        }

  field(:dataSourceId)
  field(:deletedDataPoint, as: GoogleApi.Fitness.V1.Model.DataPoint, type: :list)
  field(:insertedDataPoint, as: GoogleApi.Fitness.V1.Model.DataPoint, type: :list)
  field(:nextPageToken)
end

defimpl Poison.Decoder, for: GoogleApi.Fitness.V1.Model.ListDataPointChangesResponse do
  def decode(value, options) do
    GoogleApi.Fitness.V1.Model.ListDataPointChangesResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Fitness.V1.Model.ListDataPointChangesResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
